<template>
  <ui-clickable
    v-bind="componentProps"
    class="ui-link"
  >
    {{ text }} <slot />
  </ui-clickable>
</template>

<script lang="ts">
  import { computed, defineComponent, PropType } from 'vue'
  import { UiClickable, UiClickableProps } from '../UiClickable'
  import type { UiLinkHrefProp, UiLinkTargetProp, UiLinkToProp, UiLinkTextProp } from './type'

  export default defineComponent({
    name: 'ui-link',
    inheritAttrs: true,
    props: {
      text: {
        type: String as PropType<UiLinkTextProp>,
      },
      to: {
        type: Object as PropType<UiLinkToProp>,
      },
      href: {
        type: String as PropType<UiLinkHrefProp>,
      },
      target: {
        type: String as PropType<UiLinkTargetProp>,
      },
    },
    setup(props) {
      const componentProps = computed(() => {
        const linkProps: Omit<UiClickableProps, 'text'> = {}

        if (props.to) {
          linkProps.to = props.to
        } else if (props.href) {
          linkProps.href = props.href
          linkProps.target = props.target
        } else {
          linkProps.type = 'button'
        }

        return linkProps
      })

      return {
        componentProps,
      }
    },
    components: {
      UiClickable,
    }
  })
</script>

<style>
  .ui-link {
    @apply uikit-outline-none uikit-text-white uikit-text-opacity-60 uikit-transition-colors uikit-duration-300 uikit-ease-out hover:uikit-ease-in;
  }

  .ui-link.router-link-exact-active,
  .ui-link.router-link-active,
  .ui-link:hover {
    @apply uikit-text-opacity-100;
  }
</style>
